package com.riiiver.sample.qcc5100

import android.content.Intent
import android.os.Bundle
import androidx.activity.ComponentActivity
import androidx.activity.compose.setContent
import androidx.compose.material.MaterialTheme
import com.riiiver.sample.qcc5100.router.NavGraph
import com.riiiver.sample.qcc5100.util.firebase.FcmService
import com.riiiver.sample.qcc5100.util.riiiver.IRiiiverSdkClient
import dagger.hilt.android.AndroidEntryPoint
import javax.inject.Inject

@AndroidEntryPoint
class MyActivity : ComponentActivity() {
    // Inject RiiiverSdkClient for initialization
    @Inject lateinit var riiiverSdkClient: IRiiiverSdkClient

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        // Start FCM service
        val fcmIntent = Intent(this, FcmService::class.java)
        startService(fcmIntent)

        setContent {
            MaterialTheme {
                NavGraph()
            }
        }
    }
}