package com.riiiver.sample.qcc5100.data

import com.riiiver.sample.qcc5100.util.ble.CommandReceiverCommand
import kotlin.jvm.Throws

object QCC5100Queue {
    var current: CommandReceiverCommand? = null
        private set

    val isWaiting: Boolean
        get() = current != null

    @Throws(IllegalStateException::class)
    fun enqueue(command: CommandReceiverCommand) {
        if (isWaiting) {
            throw IllegalStateException("Queue is full. Please wait until the current command is completed.")
        }
        else {
            current = command
        }
    }

    fun dequeue() {
        current = null
    }
}
