package com.riiiver.sample.qcc5100.data

import com.riiiver.sample.qcc5100.util.ble.CommandReceiverCommand

object AssignedFeature {
    var button1: SlateFeature = DummySlateFeature.ControlMusic
        private set
    var button2: SlateFeature = DummySlateFeature.RingPhone
        private set

    fun setButton1(feature: SlateFeature) {
        button1 = feature
    }

    fun setButton2(feature: SlateFeature) {
        button2 = feature
    }

    fun getFeatureFor(command: CommandReceiverCommand): SlateFeature {
        return when (command) {
            CommandReceiverCommand.BUTTON_1_RESULT -> button1
            CommandReceiverCommand.BUTTON_2_RESULT -> button2
            else -> throw IllegalArgumentException("Invalid command: $command")
        }
    }
}

interface SlateFeature {
    val displayName: String
    val id: String
}

object DummySlateFeature {
    const val NAME_CONTROL_MUSIC = "Control the music player"
    const val NAME_RING_PHONE = "Ring the phone"
    const val ID_CONTROL_MUSIC = "control_music_id"
    const val ID_RING_PHONE = "ring_phone_id"

    data object ControlMusic: SlateFeature {
        override val displayName: String = NAME_CONTROL_MUSIC
        override val id: String = ID_CONTROL_MUSIC
    }

    data object RingPhone: SlateFeature {
        override val displayName: String = NAME_RING_PHONE
        override val id: String = ID_RING_PHONE
    }
}