package com.riiiver.sample.qcc5100.util.ble

const val CCD_UUID = "00002902-0000-1000-8000-00805f9b34fb"

const val PERIPHERAL_RIIIVER_SERVICE_UUID = "0000a000-0000-1000-8000-00805f9b34fb"

const val ON_BOARD_USER_EVENT_CHARACTERISTIC_UUID = "0000a001-0000-1000-8000-00805f9b34fb"
const val COMMAND_RECEIVER_CHARACTERISTIC_UUID = "0000a002-0000-1000-8000-00805f9b34fb"

data class SlateRiiiverPayload(
    val dataLength: ByteArray,
    val commandId: Byte,
    val message: ByteArray
) {
    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (javaClass != other?.javaClass) return false

        other as SlateRiiiverPayload

        if (!dataLength.contentEquals(other.dataLength)) return false
        if (commandId != other.commandId) return false
        if (!message.contentEquals(other.message)) return false

        return true
    }

    override fun hashCode(): Int {
        var result = dataLength.contentHashCode()
        result = 31 * result + commandId
        result = 31 * result + message.contentHashCode()
        return result
    }

    fun combine(): ByteArray {
        return dataLength + byteArrayOf(commandId) + message
    }
}
