package com.riiiver.sample.qcc5100.util.extensions

import com.riiiver.sample.qcc5100.util.ble.SlateRiiiverPayload

fun ByteArray.toHexString(): String {
    return joinToString(separator = ",") { eachByte -> String.format("%02X", eachByte) }
}

fun ByteArray.subData(start: Int, length: Int): ByteArray {
    var end = start + length
    if (end > size) {
        end = size
    }
    return copyOfRange(start, end)
}

fun ByteArray.toSlateRiiiverPayload(): SlateRiiiverPayload {
    val dataLength = subData(0, 2)
    val commandId = get(2)
    val message = subData(3, size - 3)
    return SlateRiiiverPayload(dataLength, commandId, message)
}