package com.riiiver.sample.qcc5100.util.extensions

import android.Manifest
import android.os.Build
import com.riiiver.sdk.ERPermissionType

fun ERPermissionType.toManifestPermission(): String {
    return when(this) {
        ERPermissionType.Location -> Manifest.permission.ACCESS_FINE_LOCATION
        ERPermissionType.Microphone -> Manifest.permission.RECORD_AUDIO
        ERPermissionType.Calender -> Manifest.permission.READ_CALENDAR
        ERPermissionType.Notification -> if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
            Manifest.permission.POST_NOTIFICATIONS
        } else {
            ""
        }

        ERPermissionType.NotificationAccess -> Manifest.permission.ACCESS_NOTIFICATION_POLICY
        else -> ""
    }
}