package com.riiiver.sample.qcc5100.util.riiiver

import com.google.firebase.messaging.RemoteMessage
import com.riiiver.sample.qcc5100.data.AssignedFeature
import com.riiiver.sample.qcc5100.data.SlateFeature
import com.riiiver.sample.qcc5100.util.ble.CommandReceiverCommand
import com.riiiver.sdk.ERApplet
import kotlinx.coroutines.flow.Flow
import java.net.URL

data class RiiiverSdkClientData(
    val applets: List<ERApplet> = emptyList(),
    val assigned: AssignedFeature = AssignedFeature
)

abstract class IRiiiverSdkClient: IErAppletClient, IErAuthClient {
    abstract val data: Flow<RiiiverSdkClientData>
}

interface IErAppletClient {
    suspend fun getMyApplets(): List<ERApplet>
    fun getErAppletInstance(id: String): ERApplet
    fun changeTargetApplet(of: CommandReceiverCommand, feature: SlateFeature)
    suspend fun executeTaskForRemoteNotification(remoteNotification: RemoteMessage)
}

interface IErAuthClient {
    val isLoggedIn: Flow<Boolean>
    fun startWebLogin(): URL
    suspend fun continueWebLogin(uriString: String)
    suspend fun setNotificationToken(fcmToken: String)
    suspend fun logout()
}